/* @TITLE "vnode - a contiguous node-numbering" */
/*
 * vnode.h - virtual node numbers
 *   There is a need for a set of contiguous node numbers in [0..n) for
 * n nodes, at all times. UsProc_Node works as long as ProcsInUse() is the
 * same as TotalProcsAvailable, but breaks after that. So we generate our own. 
 * Call InitVnodes once from one proc, and generator is used to give
 * each proc a unique Vnode number.
 * 
 * DFK 6/90
 */
/* $Id: vnode.h,v 7.1 91/05/09 19:29:51 dfk Tape2 $ */

extern int Vnode;			/* the virtual node number for this proc */

extern void InitVnodes();	/* generate Vnode numbers (see init.c) */
